#ifndef __GC_ph__
#define __GC_ph__

#if __cplusplus__
extern "C" {
#endif /* __cplusplus__ */

typedef void (*gc_vfunc)(void*);

void GCDumpBase ();
void GCCleanup ();
void GCStartup ();

void GCClassDelete (GCClass This);
GCClass GCClassNew (char* name, GCDeleteMethod erase);

GCObject GCObjectNew (void* address, GCClass base);

void GCReferenceMove (void** address, void** newAddress);
GCReference GCReferenceSet (void** address, const void* from, const void* to);

#if __cplusplus__
}
#endif /* __cplusplus__ */

#endif /* __GC_ph__ */
